package edu.nyu.scps.service;

import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.Service;
import android.content.Intent;
import android.os.IBinder;
import android.widget.Toast;

public class LocalService extends Service {
	private NotificationManager notificationManager;
	private static final int NOTIFICATION_ID = 0;

	@Override
	public void onCreate() {
		notificationManager = (NotificationManager)getSystemService(NOTIFICATION_SERVICE);
		showNotification();	// Put an icon in the status bar.
	}

	@Override
	public int onStartCommand(Intent intent, int flags, int startId) {
		String s = "onStartCommand ";
		if ((flags & Service.START_FLAG_REDELIVERY) != 0) {	//"bitwise and"
			s += " START_FLAG_REDELIVERY";
		}
		if ((flags & Service.START_FLAG_RETRY) != 0) {
			s += " START_FLAG_RETRY";
		}
		s += " " + startId;
		Toast.makeText(this, s, Toast.LENGTH_SHORT).show();
		// Make this service continue running until explicitly stopped.
		return START_STICKY;
	}

	@Override
	public void onDestroy() {
		// Cancel the persistent notification.
		notificationManager.cancel(NOTIFICATION_ID);
		Toast.makeText(this, "onDestroy", Toast.LENGTH_SHORT).show();
	}

	@Override
	public IBinder onBind(Intent arg0) {
		// TODO Auto-generated method stub
		return null;
	}

    /**
     * Show a notification while this service is running.
     */
	private void showNotification() {
		//This constructor is deprecated, but I couldn't get Notification.Builder to compile.
		Notification notification =
			new Notification(R.drawable.stat_sample, "Ticker Text", System.currentTimeMillis());

		// The PendingIntent to launch our activity if the user selects this notification
		Intent intent = new Intent(this, ServiceActivity.class);
		PendingIntent contentIntent =
			PendingIntent.getActivity(this, 0, intent, 0);

		// Set the info for the views that show in the notification panel.
		notification.setLatestEventInfo(this, "Content Title", "Content Text", contentIntent);

		// Send the notification.
		notificationManager.notify(NOTIFICATION_ID, notification);
	}

}
